const {
  Scene,
  Object3D,
  PerspectiveCamera,
  WebGLRenderer,
  CanvasTexture,
  Sprite,
  SpriteMaterial,
  loadTexture,
  ImageUtils,
  PointLight,
  SpriteAlignment,
  shadowMap,
  BufferGeometry,
  BufferGeometryUtils,
  CubeTextureLoader,
  MultiMaterial,
  vertices
} = THREE;

import {TerrainGenerator} from './TerrainGenerator.js';
import { getData } from './getData.js';
import { Enum } from './Texture.js';
import fragmentShader from './fragmentShader';
import vertexShader from './vertexShader';

// Tweakables
const scaleFactor = 2; // HiDPI
const width = window.innerWidth * scaleFactor;
const height = window.innerHeight * scaleFactor;
const rotationSensitivity = 0.04;
const rotationIncrement = -0.2;


// Returns a color for a given datum and number of clusters.
const camera = new PerspectiveCamera(40, width / height, 1, 100000);
const renderer = new WebGLRenderer({ antialias: true, alpha: true
                                   });

renderer.setSize(width, height);
document.body.appendChild(renderer.domElement);
renderer.domElement.style.width = width / scaleFactor + 'px';
renderer.domElement.style.height = height / scaleFactor + 'px'








var controls = new THREE.OrbitControls(camera, renderer.domElement);


const scene = new Scene();

//GROUND
const groundWidth = 10;
const groundHeight = 10;
var groundTexture = new THREE.TextureLoader().load(
  'https://raw.githubusercontent.com/stemkoski/stemkoski.github.com/master/Three.js/images/checkerboard.jpg'
);
groundTexture.wrapS = groundTexture.wrapT = THREE.RepeatWrapping;
groundTexture.repeat.set(groundWidth/4, groundHeight/4);
var groundMaterial = new THREE.MeshBasicMaterial({
  map: groundTexture,
  side: THREE.DoubleSide
});
var groundGeometry = new THREE.PlaneGeometry(groundWidth, groundHeight);
var ground = new THREE.Mesh(groundGeometry, groundMaterial);
scene.add(ground);



const csvUrl = 'https://github.com/meperezcuello/dataviz-project-template-proposal/blob/master/azeroth_31_26_heighmap.png';
const csvUrl2 = 'https://gist.githubusercontent.com/meperezcuello/eb1f6c7dabe63443aa1dafa169e51d07/raw/1c7e70db4548e8ce7eaf9c9ba21391681462651c/mountain.csv'
//** Custom Texture Mapping **//

let dict = [
    {texture:'oceanTexture', repeatedness: 5, smoothing: [0.01, 0.50]}, //<-- this is bottom texture
    {texture:'sandyTexture', repeatedness: 20, smoothing: [0.50, 0.55]},
    {texture:'snowyTexture', repeatedness: 20, smoothing: [0.55, 0.65]},
    {texture:'snowyTexture', repeatedness: 10, smoothing: [0.65, 0.75]},
    {texture:'snowyTexture', repeatedness: 20, smoothing: [0.75, 0.99]}, // <-- this is top texture
  ];

let wow = [
    {texture:'wowtest', repeatedness: 1, smoothing: [0.01, 0.01]}, //<-- this is bottom texture
  ];
  

const TerrainMain = async() => {
  



  
}
https://raw.githubusercontent.com/meperezcuello/dataviz-project-template-proposal/master/entire_optimized.png

(async() => {
const _txtr = (txtrLoad) => {
    var texture = new THREE.TextureLoader().load(txtrLoad);
    return texture;
	}



    		var depth = 576;
        var width = 1097;
        var spacingX = 3;
        var spacingZ = 3;
        var heightOffset = 2;
  
        var canvas = document.createElement('canvas');
        canvas.width = 576;
        canvas.height = 1097;
        var ctx = canvas.getContext('2d');
        var img = new Image();
  			img.crossOrigin = 'anonymous'; 
        img.src = "https://dl.dropboxusercontent.com/s/9l9349gzb0qxndi/rezise.png";

        img.onload = function () {
            // draw on canvas
            ctx.drawImage(img, 0, 0);
            var pixel = ctx.getImageData(0, 0, width, depth);
						var pix = pixel.data;
          
            var size = 576 * 1097;
   					var data = new Float32Array( size );
 
            var j=0;
            for (var i = 0; i<pix.length; i +=4) {
                var all = pix[i]+pix[i+1]+pix[i+2];
                data[j++] = all/(12*1);
            }


    
          	
    

	      console.log(data)





    var geometry = new THREE.PlaneGeometry(576, 1097, 576, 1097)
    //var vertices = geometry.attributes.position.array;
  	console.log(geometry.vertices.length)
  
          
          
        //for ( let i = 0; i <500000; i++ ) {
        //  let stride = i * 3;
				
         // vertices[ stride ] =  geom.vertices[i]['z'] ; //normalize 0 to 255
        //  vertices[ stride + 1 ] = geom.vertices[i]['x'];
        //  vertices[ stride + 2 ] = geom.vertices[i]['y'];
       // }      
          
    for ( var i = 0; i < geometry.vertices.length; i++ ) {
         geometry.vertices[i].z = data[i];
    }
 

  
  var material  = new THREE.MeshBasicMaterial({ map: _txtr('https://raw.githubusercontent.com/meperezcuello/dataviz-project-template-proposal/master/modifier.png'), transparent: true, side: THREE.DoubleSide})
     //material.bumpMap = _txtr('https://raw.githubusercontent.com/meperezcuello/dataviz-project-template-proposal/master/rezise.png')
 
  
  var earthMesh = new THREE.Mesh(geometry, material)
  scene.add(earthMesh)


   earthMesh.rotation.x = -Math.PI / 2;
   earthMesh.position.y = 0;

    }
  
 


  const waterCube = new THREE.BoxGeometry(261, 262, 1);
  
  const water = new THREE.Mesh(waterCube, new THREE.MeshPhongMaterial({color:0x214746, transparent: true, opacity: 0.80, side: THREE.DoubleSide}));
 	scene.add(water);
water.rotation.x = -Math.PI / 2;
water.position.y = 36.5;
water.receiveShadow = true;


//LIGHT
  const light = new THREE.PointLight(0xffffff, 2, 350);
  light.position.set(105, 100, 15);
  light.castShadow = true;
  light.shadow.camera.near = 0.3;
  light.shadow.camera.far = 25;
  scene.add(light);



//Init ground roration
const epsilon = -0.5;
ground.rotation.x -= Math.PI / 2;
ground.position.z = groundWidth/2 + epsilon;
ground.position.x = groundHeight/2 + epsilon;
ground.position.y = epsilon;


var axesHelper = new THREE.AxesHelper( 100 );
scene.add( axesHelper );
//Init camera position
//camera.rotation.x = Math.PI/2;
camera.position.set(300, 800, -800);


      function onDocumentKeyDown(event) {
    var keyCode = event.which;
    if (keyCode === 38) {
        console.log('hgg');
    }};

  window.addEventListener("keydown", onDocumentKeyDown, false);

const animate = () => {
  	//water.rotation.z -= 0.025;
   	//mesh.rotation.z -= 0.025;

    requestAnimationFrame(animate);
 		controls.update();
	  renderer.render(scene, camera);
};
  
  //dispose from memeory
//renderer.renderLists.dispose();
//mesh.geometry.dispose();
//mesh.material.dispose();
//scene.remove( mesh );

  
animate();
  })()