export default function vertexShader() {
  return `
    uniform sampler2D bumpTexture;
    uniform float bumpScale;
    varying float vAmount;
    varying vec2 vUV;

		varying vec3 Position;
		varying vec3 Normal;

void main() 
{ 
	Normal = normalize(normalMatrix * normal);
  Position = vec3(modelViewMatrix * vec4(position, 1.0));

	vUV = uv;
	vec4 bumpData = texture2D( bumpTexture, uv );
	
	vAmount = bumpData.r; // assuming map is grayscale it doesn't matter if you use r, g, or b.
	
	// move the position along the normal
    vec3 newPosition = position + normal * bumpScale * vAmount;
	
	gl_Position = projectionMatrix * modelViewMatrix * vec4( newPosition, 1.0 );
}
  `
}